# Release Notes for NCID 1.11

## Index

> * NCID Distributions
> * Distribution Changes
> * Server Changes
> * Gateway Changes
> * Client Changes
> * Client Output Module Changes
> * Client AppStream data Changes
> * Setup Scripts Changes
> * Udev File Changes
> * Documentation Changes

## NCID Distributions

> * SourceForge
> * Fedora packages
> * RPM based OS packages
> * Macintosh OS X package
> * FreeBSD package
> * Debian based OS packages

> ### SourceForge

>> The Fedora, FreeBSD, Raspbian and Ubuntu packages may be included in repositories.

            NCID source package:           ncid-1.11-src.tar.gz

            Cygwin Windows package:        ncid-1.11-cygwin64_install.sh

            Debian packages:               Raspbian and Ubuntu are Debian packages

            Fedora 64 bit packages:        ncid-1.11-1.fc31.x86_64.rpm
                                           ncid-gateways-1.11-1.fc31.x86_64.rpm

            Fedora no-arch packages:       ncid-client-1.11-1.fc31.noarch.rpm
                                           ncid-kpopup-1.11-1.fc31.noarch.rpm
                                           ncid-mysql-1.11-1.fc31.noarch.rpm
                                           ncid-mythtv-1.11-1.fc31.noarch.rpm
                                           ncid-samba-1.11-1.fc31.noarch.rpm
                                           ncid-speak-1.11-1.fc31.noarch.rpm

            FreeBSD 64 bit package:        ncid-1.11-FreeBSD-1.11_install.sh

            Macintosh 64 bit OS X package: ncid-1.11-mac-osx_install.sh
            (Universal binary, OSX 10.5+)

            Raspbian 32 bit packages:      ncid_1.11-1_armhf.deb
            (Raspberry Pi)                 ncid-gateways_1.11-1_armhf.deb

            Ubuntu 64 bit packages:        ncid_1.11-1_amd64.deb
                                           ncid-gateways_1.11-1_amd64.deb

            Raspbian and Ubuntu no-arch packages:
                                           ncid-client_1.11-1_all.deb
                                           ncid-kpopup_1.11-1_all.deb
                                           ncid-mysql_1.11-1_all.deb
                                           ncid-mythtv_1.11-1_all.deb
                                           ncid-samba_1.11-1_all.deb
                                           ncid-speak_1.11-1_all.deb

            Windows client installer:      ncid-1.11-client_windows_setup.exe

> ### Fedora packages

>> A new release of NCID is first available at Sourceforge. Sometime later it is available
   at the Fedora repositories which includes the Rawhide repository for the next Fedora
   release.

>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** rpm packages.  The **ncid-gateways** is installed if needed..

>> The dnf list command will show you the packages available:
>>
          dnf list ncid\*

>> If the above does not show version 1.11:
>>
          dnf --enablerepo=rawhide list ncid\*

>> If the rawhide repo is not installed:
>>
          dnf install fedora-release-rawhide

>> If you need to build packages for your specific OS release:
>>
          rpmbuild -tb ncid-1.11-src.tar.gz

> ### RPM based OS packages

>> Includes Fedora, Redhat, CentOS, etc.

>> If a dependency can not be resolved, you should try rebuilding packages:
>>
    - Download the latest NCID RPM packages from SourceForge:
      ncid RPM Package          - server, extensions and tools
      ncid-gateways RPM Package - gateways (if using a gateway)
      ncid-client RPM Package   - client and default output modules
                                  (if using this client)
    - Download any optional output modules wanted:
      ncid-MODULE RPM Package  - optional client output modules
    - Install or Upgrade the packages using dnf
          * Install the NCID server and gateways:
            sudo dnf install ncid-<version>.fc31.x86_64.rpm
          * Install the client package and default modules:
            sudo dnf install ncid-client-<version>.fc31.noarch.rpm
          * Install any optional modules wanted:
            sudo dnf ncid-<module>-<version>.fc31.noarch.rpm
>>
    Notes:
        <version> would be something like: 1.11-1
        <module> would be: kpopup, mysql, mythtv, samba, speak

> ### Macintosh OS X package

>> The version available at MacPorts is 0.83 which was released
>> October 2011. It is not currently maintained:
>>
>>> http://trac.macports.org/browser/trunk/dports/net/ncid/Portfile
>>
>> Use the version available at SourceForge.

> ### FreeBSD package

>> Available at FreshPorts.
>>
>>> http://www.freshports.org/comms/ncid/

> ### Debian based OS packages

>> Includes Debian, Raspbian, Ubuntu, etc.

>> Install from the files at SourceForge:
>>
    - Download the latest NCID DEB packages from SourceForge:
      ncid DEB Package          - server, extensions and tools
      ncid-gateways DEB Package - gateways (if using a gateway)
      ncid-client DEB Package   - client and default output modules
                                  (if using this client)
>>
    - Download any optional output modules wanted:
      ncid-MODULE DEB Package   - optional client output modules
>>
    - Install or Upgrade the packages using apt or apt-get (command line):
        * Install the NCID server and gateways:
          sudo apt install ./ncid-<version>_<processor>.deb
        * Install the client package and default modules:
          sudo apt install ./ncid-client-<version>_all.deb
        * Install any optional modules:
          sudo apt install ncid-<module>-<version>_all.deb
>>
    Notes:
        <version> would be something like: 1.11-1
        <processor> would be: i386, armhf, amd64
        <module> would be: kpopup, mysql, mythtv, samba, speak

>> If you need to build a package for your specific OS or release, the
  build-essential, fakeroot and libpcap packages must be installed:
>>
          sudo apt-get build-essential fakeroot libpcap0.8-dev
          tar -xzf ncid-1.11-src.tar.gz
          mv ncid ncid-1.11
          cd ncid-1.11
          fakeroot debian/rules build
          fakeroot debian/rules binary
          fakeroot debian/rules clean

## Server Changes

> ncidd:

>- Fixed simple expressions to match on the alias size.
>- cidinput 2 no longer disables CIDINFO lines, and now sends call end codes like -4
>- fixed memory leak for cidinput 2 and 3
>- fixed missing caller ID output when caller arrives before 1st RING and for 2nd ring gencid
>- lockfile is tested to make sure it can be created
>- misc code improvements
>- new - added '$' to simple expressions to match at end of string

> ncidd.conf:

>- changed README.udev to README-udev

> ncidd.alias

>- updated comments for simple expressions to include $

> ncidd.blacklist

>- updated comments for simple expressions to include $

> ncidd.whitelist:

>- corrected typo: bust to must

>- updated comments for simple expressions to include $

## Service Files Changes:

> ncidd.service:

>- added: Requires=network.target

> all service files (except ncidd.service)

>- replaced: Wants=ncidd.service with:     Requires=ncidd.service

## Udev Files Changes (Linux Only)

> rule files

>- changed default from /usr/local to /usr

## Gateway Changes

> sip2ncid:

>- added support for BSD loopback devices
>- added diagnostic message to show device linktype
>- allow loopback devices for software VPN
>- misc code improvements

> ncid2ncid:

>- added hostname to the client messages about lost or regained fromhosts
>- updated linetype[]

> all gateways default configure directory:

>- changed from /usr/local/etc/ncid to /etc/ncid

## Client Changes

> ncid:

> - fixed hangup crashing ncid when the lineid contains one of more spaces.
>- new - portable mode detection
>- new - GUI mode: support for multiple servers
>- new - view selected line types and lineids
>- new - copy name from history window to clipboard
>- new - --conf-file|-f command line option
>- new - optional client log file
>- new - GUI mode: request server to dial number entered manually
>- new - GUI mode: US only: oprion of removing a leading 1, adding a leading 1 or leaving number as is
>- new - command line arguments can take two additional forms like -v1 and iiverbose=1
>- misc code improvements

## Client Output Module Changes

> all modules:

>- changed default from /usr/local/etc to /etc
>- changed -P option to -m option

> ncid-notify.conf:

>- changed -P option to -m option

## Client AppStream data Changes

## Tools Changes

> cidupdate:
>- retwrite with more options, increased speed and fixes

## Documentation Changes

> Updated Manual Pages:

>- all manual pages updated

> new man page

>- get-areacodes-list.1

> Updated User Manual:

>- Alias.md
>- Modules.md
>- Devices.md
>- FCCData.md
>- GettingStarted.md
>- Hangup.md
>- INSTALL-Cygwin.md
>- INSTALL-DEB.md
>- INSTALL-FreeBSD.md
>- INSTALL-Win.md
>- INSTALL.md
>- Modules.md
>- NCID-API.md
>- Tools.md
>- Use.md
>- Verbose.md

> Updated API:

> - changed README.test README-test

> Updated User Manual template:

> - NCID-UserManual-pdf.md
